function [TimePCL,accPCL,tempPCL,ErrPreConvLink] = defDatiPCL(DatiPreConvLink,...
    ErrPreConvLink,Ndatidespike,rPCL,MEMS,FileName)

fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'defDatiPCL function started';
fprintf(fileID,fmt,text);

[r,c] = size(DatiPreConvLink);
Ncorr = 0;
% Elimino gli eventuali Not a Number
for a = 2:r
    for b = 2:c
        check = isnan(DatiPreConvLink(a,b));
        if check == 1
            DatiPreConvLink(a,b) = DatiPreConvLink(a-1,b);
            ErrPreConvLink(a,b-1) = 1;
            Ncorr = Ncorr+1;
        end
    end
end

text = ['' num2str(Ncorr) ' NaN of PreConv Link corrected by defDatiPCL function'];
fprintf(fileID,fmt,text);

% Definisco Data (gg:mm:aaaa hh:mm), Batteria, i 3 dati di accelerometro
% e magnetometro e la Temperatura per la calibrazione
TimePCL = DatiPreConvLink(:,1); % data
accPCL = zeros(r,rPCL*3); % dati accelerometro
tempPCL = zeros(r,rPCL); % temperatura del nodo per la calibrazione
p = 4; % passo nella definizione dei dati
s = 1;

for i = 1:rPCL
    accPCL(:,s) = DatiPreConvLink(:,2+(i-1)*p);
    accPCL(:,s+1) = DatiPreConvLink(:,3+(i-1)*p);
    accPCL(:,s+2) = DatiPreConvLink(:,4+(i-1)*p);    
    s = s+3;
    tempPCL(:,i) = DatiPreConvLink(:,5+(i-1)*p);
    if MEMS == 2
        [rT,~] = size(tempPCL);
        for j = 1:rT
            if tempPCL(j,i) > 200
                tempPCL(j,i) = tempPCL(j,i) - 256; % Correzione della temperatura dei nuovi MEMS
            end
        end
    end
end

s = 1;
Num_Dati = Ndatidespike; % numero di dati per il despike
if Num_Dati > r
    Num_Dati = r;
end
for i = 1:rPCL
    % despiking accelerometri
    accPCL(:,s) = filloutliers(accPCL(:,s),'linear','movmedian',Num_Dati);
    accPCL(:,s+1) = filloutliers(accPCL(:,s+1),'linear','movmedian',Num_Dati);
    accPCL(:,s+2) = filloutliers(accPCL(:,s+2),'linear','movmedian',Num_Dati);
    s = s+3;
end

text = 'Data of PreConv Link defined correctly. defDatiPCL function closed';
fprintf(fileID,fmt,text);
fclose(fileID);

end